'+--------------------------------------------------------------------------+
'|                                                                          |
'|                                 Test.dll                                  |
'|                                                                          |
'|                 Win32 DLL booster for the WD16 Fly project               |
'|                                                                          |
'|                              Version 2.00                                |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                                                                          |
'|                         copyright(c) 2011-2012                           |
'|                                                                          |
'|                Patrice Terrier http://www.zapsolution.com                |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 09-24-2011 (MM-DD-YYYY)            |
'|                        Last revised : 09-15-2012 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+
'

#COMPILE DLL "Test.dll"
#DIM ALL
#INCLUDE "WIN32API.INC"


DECLARE FUNCTION zTrace LIB "zTrace.DLL" ALIAS "zTrace" (zMessage AS ASCIIZ) AS LONG
DECLARE FUNCTION zDebug LIB "zTrace.DLL" ALIAS "zDebug" (zMessage AS ASCIIZ) AS LONG

$Anti               = "\"
$zLim               = "|"

%FWALLPAPER         = 1
%FWMOVIE            = 2
$FWALLPAPER         = "FWALLPAPER"
$FWMOVIE            = "FWMOVIE"

%TIMER_GENERIC      = 11111
%TIMER_SPINNER      = 11112

%PixelFormatIndexed     = &h00010000 ' Indexes into a palette
%PixelFormatGDI         = &h00020000 ' Is a GDI-supported format
%PixelFormatAlpha       = &h00040000 ' Has an alpha component
%PixelFormatPAlpha      = &h00080000 ' Pre-multiplied alpha
%PixelFormatExtended    = &h00100000 ' Extended color 16 bits/channel
%PixelFormatCanonical   = &h00200000
%PixelFormatUndefined   = 0
%PixelFormatDontCare    = 0
%SHIFT_LEFT_1_8  = 256
%SHIFT_LEFT_4_8  = 1024
%SHIFT_LEFT_8_8  = 2048
%SHIFT_LEFT_16_8 = 4096
%SHIFT_LEFT_24_8 = 6144
%SHIFT_LEFT_32_8 = 8192
%SHIFT_LEFT_48_8 = 12288
%SHIFT_LEFT_64_8 = 16384
%PixelFormat1bppIndexed     =  1 OR %SHIFT_LEFT_1_8  OR %PixelFormatIndexed OR %PixelFormatGDI
%PixelFormat4bppIndexed     =  2 OR %SHIFT_LEFT_4_8  OR %PixelFormatIndexed OR %PixelFormatGDI
%PixelFormat8bppIndexed     =  3 OR %SHIFT_LEFT_8_8  OR %PixelFormatIndexed OR %PixelFormatGDI
%PixelFormat16bppGrayScale  =  4 OR %SHIFT_LEFT_16_8 OR %PixelFormatExtended
%PixelFormat16bppRGB555     =  5 OR %SHIFT_LEFT_16_8 OR %PixelFormatGDI
%PixelFormat16bppRGB565     =  6 OR %SHIFT_LEFT_16_8 OR %PixelFormatGDI
%PixelFormat16bppARGB1555   =  7 OR %SHIFT_LEFT_16_8 OR %PixelFormatAlpha OR %PixelFormatGDI
%PixelFormat24bppRGB        =  8 OR %SHIFT_LEFT_24_8 OR %PixelFormatGDI
%PixelFormat32bppRGB        =  9 OR %SHIFT_LEFT_32_8 OR %PixelFormatGDI
%PixelFormat32bppARGB       = 10 OR %SHIFT_LEFT_32_8 OR %PixelFormatAlpha OR %PixelFormatGDI OR %PixelFormatCanonical
%PixelFormat32bppPARGB      = 11 OR %SHIFT_LEFT_32_8 OR %PixelFormatAlpha OR %PixelFormatPAlpha OR %PixelFormatGDI
%PixelFormat48bppRGB        = 12 OR %SHIFT_LEFT_48_8 OR %PixelFormatExtended
%PixelFormat64bppARGB       = 13 OR %SHIFT_LEFT_64_8 OR %PixelFormatAlpha OR %PixelFormatCanonical OR %PixelFormatExtended
%PixelFormat64bppPARGB      = 14 OR %SHIFT_LEFT_64_8 OR %PixelFormatAlpha OR %PixelFormatPAlpha OR %PixelFormatExtended
%PixelFormatMax             = 15

'DECLARE FUNCTION RtlDecompressBuffer LIB "ntdll.dll" ALIAS "RtlDecompressBuffer" ( _
'        BYVAL CompressionFormat AS WORD, _
'        BYVAL ptrDestBuffer     AS DWORD, _
'        BYVAL DestBufferSize    AS LONG, _
'        BYVAL ptrSrceBuffer     AS DWORD, _
'        BYVAL SceBufferSize     AS LONG, _
'        BYREF pDestinationSize  AS LONG ) AS LONG

TYPE MYBITMAPINFO
    bmiHeader AS BITMAPINFOHEADER
    bmiColors(256) AS RGBQUAD ' Patrice
END TYPE

%TH32CS_SNAPALL     = 15
%PROCESS_TERMINATE  = &H0001
%PROCESS_QUERY_INFORMATION = &H0400
%PROCESS_VM_READ    = &H0010

'TYPE PROCESSENTRY32
'   dwSize AS DWORD
'   cntUsage AS DWORD
'   th32ProcessID AS DWORD
'   th32DefaultHeapID AS DWORD PTR
'   th32ModuleID AS DWORD
'   cntThreads AS DWORD
'   th32ParentProcessID AS DWORD
'   pcPriClassBase AS LONG
'   dwFlags AS LONG
'   szExeFile AS ASCIIZ * %MAX_PATH
'END TYPE

'DECLARE FUNCTION CreateToolhelp32Snapshot LIB "kernel32.dll" ALIAS "CreateToolhelp32Snapshot" (BYVAL dwFlags AS DWORD, BYVAL th32processID AS DWORD) AS LONG
'DECLARE FUNCTION Process32First LIB "kernel32.dll" ALIAS "Process32First" ( BYVAL hHandle AS LONG, rProc AS PROCESSENTRY32) AS LONG
'DECLARE FUNCTION Process32Next LIB "kernel32.dll" ALIAS "Process32Next" ( BYVAL hHandle AS LONG, rProc AS PROCESSENTRY32) AS LONG
'DECLARE FUNCTION TerminateProcess LIB "KERNEL32.DLL" ALIAS "TerminateProcess" (BYVAL hProcess AS DWORD, BYVAL uExitCode AS DWORD) AS LONG
'DECLARE FUNCTION CloseHandle LIB "KERNEL32.DLL" ALIAS "CloseHandle" (BYVAL hObject AS DWORD) AS LONG
'DECLARE FUNCTION OpenProcess LIB "KERNEL32.DLL" ALIAS "OpenProcess" (BYVAL dwDesiredAccess AS DWORD, BYVAL bInheritprocHandle AS LONG, BYVAL dwProcessId AS DWORD) AS DWORD
'DECLARE FUNCTION GetModuleFileNameEx LIB "PSAPI.DLL" ALIAS "GetModuleFileNameExA" (BYVAL hProcess AS DWORD, BYVAL hModule AS DWORD, lpFilename AS ASCIIZ, BYVAL nSize AS DWORD) AS DWORD

'DECLARE FUNCTION MyCreateDIBSection LIB "GDI32.DLL" ALIAS "CreateDIBSection" (BYVAL hdc AS DWORD, pbmi AS MYBITMAPINFO, BYVAL dwUsage AS DWORD, BYVAL ppvBits AS DWORD, BYVAL hSection AS DWORD, BYVAL dwOffset AS DWORD) AS DWORD
'DECLARE FUNCTION MyGetDIBits LIB "GDI32.DLL" ALIAS "GetDIBits" (BYVAL hdc AS DWORD, BYVAL hBitmap AS DWORD, BYVAL nStartScan AS DWORD, BYVAL nNumScans AS DWORD, lpBits AS ANY, lpBI AS MYBITMAPINFO, BYVAL wUsage AS DWORD) AS LONG

'// BASS_ChannelSetSync types
%BASS_ATTRIB_TEMPO       = &H10000
%BASS_ATTRIB_TEMPO_PITCH = &H10001
%BASS_ATTRIB_TEMPO_FREQ  = &H10002

TYPE SpriteDataStruct
    ImageName AS ASCIIZ * 128
    hBitmap   AS LONG
    ID        AS LONG
    xPos      AS LONG
    yPos      AS LONG
    nWidth    AS LONG
    nHeight   AS LONG
    rAngle    AS SINGLE
END TYPE

%MAXCHANNEL      = 8
%BASS_FX_PARAMEQ = 7

TYPE BASS_FXPARAMEQ             ' DSFXParamEq
    fCenter AS SINGLE
    fBandwidth AS SINGLE
    fGain AS SINGLE
END TYPE

DECLARE FUNCTION BASS_ChannelPause LIB "bass.dll" ALIAS "BASS_ChannelPause" (BYVAL nChannel AS DWORD) AS LONG
DECLARE FUNCTION BASS_ChannelPlay LIB "bass.dll" ALIAS "BASS_ChannelPlay" (BYVAL nChannel AS DWORD, BYVAL restart AS LONG) AS LONG
DECLARE FUNCTION BASS_ChannelRemoveSync LIB "bass.dll" ALIAS "BASS_ChannelRemoveSync"(BYVAL nChannel AS DWORD, BYVAL nSync AS LONG) AS LONG

DECLARE FUNCTION ChannelSetSync LIB "bass.dll" ALIAS "BASS_ChannelSetSync" (BYVAL nChannel AS DWORD, BYVAL pbType AS DWORD, BYVAL param AS QUAD, BYVAL proc AS DWORD, BYVAL USER AS DWORD) AS LONG
DECLARE FUNCTION ChannelSetPosition LIB "bass.dll" ALIAS "BASS_ChannelSetPosition" (BYVAL nChannel AS DWORD, BYVAL nPos AS QUAD, BYVAL nMode AS DWORD) AS LONG
DECLARE FUNCTION BASS_ErrorGetCode LIB "bass.dll" ALIAS "BASS_ErrorGetCode" () AS LONG
DECLARE FUNCTION BASS_ChannelSetAttribute LIB "bass.dll" ALIAS "BASS_ChannelSetAttribute" (BYVAL DWORD, BYVAL DWORD, BYVAL SINGLE) AS LONG
DECLARE FUNCTION BASS_ChannelGetLength LIB "bass.dll" ALIAS "BASS_ChannelGetLength" (BYVAL DWORD, BYVAL DWORD) AS QUAD
DECLARE FUNCTION BASS_ChannelSetFX LIB "bass.dll" ALIAS "BASS_ChannelSetFX" (BYVAL UseChannel AS LONG, BYVAL pbType AS DWORD, BYVAL priority AS LONG) AS LONG
DECLARE FUNCTION BASS_FXGetParameters LIB "bass.dll" ALIAS "BASS_FXGetParameters" (BYVAL UseChannel AS LONG, BYVAL par AS DWORD) AS LONG
DECLARE FUNCTION BASS_FXSetParameters LIB "bass.dll" ALIAS "BASS_FXSetParameters" (BYVAL UseChannel AS LONG, BYVAL par AS DWORD) AS LONG
DECLARE FUNCTION BASS_ChannelRemoveFX LIB "bass.dll" ALIAS "BASS_ChannelRemoveFX" (BYVAL UseChannel AS LONG, BYVAL fx AS DWORD) AS LONG

GLOBAL gnPos AS QUAD, ghChannel(), gnSync() AS LONG

GLOBAL WM_BASSSYNC, ghParent AS DWORD

GLOBAL gnCtrl, gnCarousel, gnBackList, gnStaticHandle, gnLyric AS DWORD
GLOBAL gnBackground AS LONG
GLOBAL gzSkinPath AS ASCIIZ * %MAX_PATH
GLOBAL WM_SKINTHEME AS DWORD
GLOBAL gzSkinBackground AS ASCIIZ * %MAX_PATH

GLOBAL ghWnd, ghImg AS DWORD
GLOBAL gnW, gnH, gnFrameCount, gnFrameToUse, gnUseSpeed, gnCloseThread, gnLastSync AS LONG
GLOBAL gnIsHorizontal AS LONG
GLOBAL gsCfg() AS STRING

GLOBAL gSpriteData() AS SpriteDataStruct
GLOBAL gFX() AS LONG

SUB SyncProc(BYVAL nSync AS LONG, BYVAL nChannel AS DWORD, BYVAL nData AS LONG, BYVAL nUser AS DWORD)
    LOCAL nRet AS LONG

    'LOCAL nQuadPos AS QUAD
    'nQuadPos = BASS_ChannelGetLength(nChannel, 0) - 1 ' 1764
    'IF gnPos < nQuadPos THEN nQuadPos = gnPos
    'nRet = ChannelSetPosition(nChannel, nQuadPos, 0)

    nRet = ChannelSetPosition(nChannel, gnPos, 0)
'zTrace(str$(nRet)+str$(nQuadPos))
'IF nRet = 0 THEN
'   nRet = BASS_ErrorGetCode()
'   zTrace(">>>" +str$(nRet)+str$(BASS_ChannelGetLength(nChannel, 0)))
'END IF
    IF nSync = gnLastSync AND WM_BASSSYNC THEN PostMessage(nUser, WM_BASSSYNC, 0, 0)
END SUB

FUNCTION FLY_ChannelSetSync ALIAS "FLY_ChannelSetSync" (BYVAL nChannel AS DWORD, BYVAL nType AS DWORD, BYVAL nPos AS DWORD, BYVAL nProc AS DWORD, BYVAL nUser AS DWORD) EXPORT AS LONG
    LOCAL K AS LONG, nQuadPos AS QUAD
    IF WM_BASSSYNC = 0 THEN WM_BASSSYNC = RegisterWindowMessageA("BassSyncMessage")
    nQuadPos = nPos
    gnLastSync = 0
    FOR K = 1 TO %MAXCHANNEL - 1
        gnSync(K) = 0
        IF ghChannel(K) THEN
           gnSync(K) = ChannelSetSync(ghChannel(K), nType, nQuadPos, CODEPTR(SyncProc), nProc)
           gnLastSync = gnSync(K)
        END IF
    NEXT
    FUNCTION = gnSync(1)
END FUNCTION

SUB UrlSyncProc(BYVAL nSync AS LONG, BYVAL nChannel AS DWORD, BYVAL nData AS LONG, BYVAL nUser AS DWORD)
    IF WM_BASSSYNC THEN PostMessage(nUser, WM_BASSSYNC, 1, 0)
END SUB
FUNCTION FLY_ChannelUrlSetSync ALIAS "FLY_ChannelUrlSetSync" (BYVAL nChannel AS DWORD, BYVAL nType AS DWORD, BYVAL nPos AS DWORD, BYVAL nProc AS DWORD, BYVAL nUser AS DWORD) EXPORT AS LONG
    LOCAL nQuadPos AS QUAD
    IF WM_BASSSYNC = 0 THEN WM_BASSSYNC = RegisterWindowMessage("BassSyncMessage")
    nQuadPos = nPos
    FUNCTION = ChannelSetSync(nChannel, nType, nQuadPos, CODEPTR(UrlSyncProc), nProc)
END FUNCTION

SUB FLY_ChannelRemoveSync ALIAS "FLY_ChannelRemoveSync" () EXPORT
    LOCAL K AS LONG
    FOR K = 1 TO %MAXCHANNEL - 1
        IF gnSync(K) THEN
           BASS_ChannelRemoveSync(ghChannel(K), gnSync(K))
           gnSync(K) = 0
        END IF
    NEXT
END SUB

FUNCTION FLY_Busy ALIAS "FLY_Busy" (BYVAL nBusy AS LONG, BYVAL RW AS LONG) EXPORT AS LONG
    STATIC nWasBusy AS LONG
    IF RW THEN nWasBusy = nBusy
    FUNCTION = nWasBusy
END FUNCTION
SUB FLY_Timer(dwTime AS DWORD, dwProc AS DWORD, BYVAL RW AS LONG)
    STATIC WasTime, WasProc AS DWORD
    IF RW THEN WasTime = dwTime: WasProc = dwProc
    dwTime = WasTime: dwProc = WasProc
END SUB
SUB FLY_TimerPoc(BYVAL hWnd AS DWORD, BYVAL Msg AS DWORD, BYVAL TimerID AS DWORD, BYVAL dwTime AS DWORD)
    STATIC FLYcount AS LONG

    LOCAL dwT, dwProc AS DWORD
    IF FLY_Busy(0, 0) = 0 THEN
       CALL FLY_Timer(dwT, dwProc, 0)
       IF dwProc THEN
          IF FLYcount = 0 THEN FLYcount = GetTickCount() + dwT
          IF GetTickCount() >= FLYcount THEN
             CALL DWORD dwProc
             FLYcount = 0
          END IF
       END IF
    END IF
END SUB

SUB FLY_Init ALIAS "FLY_Init" (BYVAL hWnd AS DWORD, BYVAL dwTime AS DWORD, BYVAL dwProc AS DWORD) EXPORT
    IF hWnd THEN
       ghParent = hWnd

       CALL FLY_Timer(dwTime, dwProc, 1)
       CALL SetTimer(ghParent, %TIMER_GENERIC, 0, CODEPTR(FLY_TimerPoc))
       REDIM gFX(10, %MAXCHANNEL - 1)

    END IF
END SUB

SUB FLY_Release ALIAS "FLY_Release" () EXPORT
    IF ghParent THEN
       KillTimer(ghParent, %TIMER_GENERIC)
    END IF
END SUB

'
%ALPHA_MIN              = 85
%ALPHA_STEP             = 15

%ID_BACKGROUND          = -999
%ID_CAROUSELBACK        = -998

%ID_LEFT_ARROW          = -2
%ID_RIGHT_ARROW         = -3
'%ID_SPINNER             = -4
%ID_LOGO                = -5
%ID_RECT                = -6
%ID_LYRIC               = -7

SUB ListDeleteAll(BYVAL hList AS LONG)
    IF hList THEN CALL SendMessageA(hList, %LB_RESETCONTENT, 0, 0)
END SUB

SUB ListSelectPlus(BYVAL hList AS LONG, BYVAL nSelected AS LONG)
    IF nSelected > 0 THEN DECR nSelected '// Because ListBox is zero based
    IF hList THEN CALL SendMessageA(hList, %LB_SETCURSEL, nSelected, 0)
END SUB

FUNCTION ListFindString(BYVAL hList AS LONG, zTmp AS ASCIIZ) AS LONG
    LOCAL nIndex AS LONG
    nIndex = SendMessageA(hList, %LB_FINDSTRING, -1, VARPTR(zTmp))
    IF nIndex > -1 THEN INCR nIndex: FUNCTION = nIndex
END FUNCTION

FUNCTION ListCount(BYVAL hList AS LONG) AS LONG
    IF hList THEN FUNCTION = SendMessageA(hList, %LB_GETCOUNT, 0, 0)
END FUNCTION

FUNCTION ListGetCursel(BYVAL hList AS LONG) AS LONG
    LOCAL nSelected AS LONG
    IF hList THEN
       nSelected = SendMessageA(hList, %LB_GETCURSEL, 0, 0)
       IF nSelected > -1 THEN INCR nSelected '// Because ListBox is zero based
    END IF
    FUNCTION = nSelected
END FUNCTION

FUNCTION ListAdd(BYVAL hList AS LONG, zTmp AS ASCIIZ) AS LONG
    IF hList THEN
       IF LEN(zTmp) THEN FUNCTION = SendMessageA(hList, %LB_ADDSTRING, 0, VARPTR(zTmp))
    END IF
END FUNCTION

FUNCTION ListGetText(BYVAL hList AS LONG, BYVAL Item AS LONG) AS STRING
    LOCAL sItem AS STRING, nLEN AS LONG
    IF Item > 0 THEN
       DECR Item
       nLEN = SendMessageA(hList, %LB_GETTEXTLEN, Item, 0)
       sItem = SPACE$(nLEN)
       CALL SendMessageA(hList, %LB_GETTEXT, Item, BYVAL STRPTR(sItem))
       FUNCTION = sItem
    END IF
END FUNCTION

FUNCTION GetStaticValue ALIAS "GetStaticValue" (zUseString AS ASCIIZ) EXPORT AS LONG
    LOCAL sUseString AS STRING, nValue, nIndex AS LONG
    sUseString = zUseString + $zLim
    nValue = 0
    IF gnStaticHandle THEN
       nIndex = SendMessageA(gnStaticHandle, 399, -1, STRPTR(sUseString))
       IF nIndex > -1 THEN '// We found it
          nValue = SendMessageA(gnStaticHandle, 409, nIndex, 0)
       END IF
    END IF
    FUNCTION = nValue
END FUNCTION

FUNCTION zInstance () AS LONG
    FUNCTION = GetModuleHandleA("")
END FUNCTION

SUB SetStaticValue ALIAS "SetStaticValue" (zUseString AS ASCIIZ, BYVAL nValue AS LONG) EXPORT
    LOCAL sUseString AS STRING, nIndex AS LONG
    sUseString = zUseString + $zLim
    IF gnStaticHandle = 0 THEN
       gnStaticHandle = CreateWindowExA(0, "LISTBOX", "", %WS_CHILD OR %LBS_HASSTRINGS, 0, 0, 0, 0, GetParent(gnCtrl), 0, zInstance(), BYVAL %NULL)
    END IF
    IF gnStaticHandle THEN
       nIndex = SendMessageA(gnStaticHandle, 399, -1, STRPTR(sUseString))
       IF nIndex > -1 THEN '// We found same static
          CALL SendMessageA(gnStaticHandle, 410, nIndex, nValue)
       ELSE '// Add it to our static list
          CALL SendMessageA(gnStaticHandle, 410, SendMessageA(gnStaticHandle, 384, 0, STRPTR(sUseString)), nValue)
       END IF
    END IF
END SUB


FUNCTION zsGetTempPath () AS STRING
    LOCAL sTempPath AS STRING, nSize AS LONG
    sTempPath = SPACE$(GetTempPathA(0, BYVAL %NULL))
    nSize = GetTempPathA(LEN(sTempPath), BYVAL STRPTR(sTempPath))
    sTempPath = RTRIM$(sTempPath, ANY CHR$(0,92))
    sTempPath = sTempPath + $Anti
    FUNCTION = sTempPath
END FUNCTION

'// Safe delete for GDI objects.
SUB zDeleteObject (hObject AS LONG)
    IF hObject THEN CALL DeleteObject(hObject): hObject = 0
END SUB

'///////////////////////////////////////////

FUNCTION LIBMAIN(BYVAL hInstance AS DWORD, BYVAL fwdReason AS LONG, BYVAL lpvReserved AS LONG) EXPORT AS LONG

    SELECT CASE AS LONG fwdReason
    CASE 1 '// %DLL_PROCESS_ATTACH
           IF WM_SKINTHEME = 0 THEN WM_SKINTHEME = RegisterWindowMessageA("GDImageSkinTheme")
           DIM ghChannel(1 TO %MAXCHANNEL), gnSync(1 TO %MAXCHANNEL)

    CASE 0 '// %DLL_PROCESS_DETACH
           zDeleteObject(gnBackground)
           zsKillFile(gzSkinBackground)
    END SELECT

    FUNCTION = 1 '// %TRUE

END FUNCTION

SUB UseThisChannel ALIAS "UseThisChannel" (BYVAL nC AS LONG, BYVAL nHandle AS LONG) EXPORT
    IF nC > 0 AND nC < %MAXCHANNEL + 1 THEN ghChannel(nC) = nHandle
END SUB

SUB UseThisSyncPos ALIAS "UseThisSyncPos" (BYVAL nPos AS LONG) EXPORT
    gnPos = nPos
END SUB


'//////////////////////////////////////////////////
GLOBAL gnThemeID AS LONG, gsWasLabelName AS STRING
GLOBAL ID_MAX_SPRITE, gnTopCarouseID AS LONG

SUB ZSL_UpdateSkinPath ALIAS "ZSL_UpdateSkinPath" (szSkinPath AS ASCIIZ) EXPORT
    gzSkinPath = szSkinPath
END SUB


'// Fill the background listbox
SUB DetectBackground(szUseBackground AS ASCIIZ)
    LOCAL WashFind, hFind AS LONG
    LOCAL fd AS WIN32_FIND_DATA
    LOCAL zTmp AS ASCIIZ * %MAX_PATH
    LOCAL szBackPath AS ASCIIZ * %MAX_PATH
'    LOCAL nActiveBackgroundSize AS QUAD
    LOCAL nItemSize AS QUAD

    szBackPath = PATHNAME$(PATH, szUseBackground)

    CALL ListDeleteAll(gnBackList)

    WashFind = FindFirstFile(szBackPath + "*.*", fd)
    hFind = WashFind
    DO WHILE hFind > 0
       IF ASC(fd.cFileName) <> 46 THEN
          IF INSTR(CHR$(0,1,32,33,128), CHR$(fd.dwFileAttributes)) THEN
             zTmp = szBackPath + fd.cFileName: CALL CharLowerA(zTmp)
             IF INSTR(".gif.bmp.png.jpg.", RIGHT$(zTmp, 4) + ".") THEN
                nItemSize = MAK(QUAD, fd.nFileSizeLow, fd.nFileSizeHigh)
                IF ListAdd(gnBackList, zTmp) > -1 THEN
''                  // If same size, then we assume it is our current background...
'                   IF nItemSize = nActiveBackgroundSize THEN zBackground = zTmp
                END IF
             END IF
          END IF
       END IF
       hFind = FindNextFile(WashFind, fd)
    LOOP
    CALL FindClose(WashFind)

    gnThemeID = ListFindString(gnBackList, szUseBackground)

    CALL ListSelectPlus(gnBackList, gnThemeID)

END SUB


FUNCTION ZSL_ActiveTheme ALIAS "ZSL_ActiveTheme" () EXPORT AS STRING
    FUNCTION = ListGetText(gnBackList, ListGetCursel(gnBackList))
END FUNCTION
FUNCTION zsFOpen (zFilName AS ASCIIZ, BYVAL AccessMode AS LONG, BYVAL ShareMode AS LONG, hFile AS LONG) AS LONG

    LOCAl AccessIs, ShareIs, FlagAndAttribute AS LONG

    AccessMode = MIN(MAX(AccessMode, 0), 2)  ' Coherce between 0-2
    IF AccessMode = 0 THEN                   ' 0 Open for read only.
       AccessIs = %GENERIC_READ
    ELSEIF AccessMode = 1 THEN               ' 1 Open for write only.
       AccessIs = %GENERIC_WRITE
    ELSE                                     ' 2 Open for read and write.
       AccessIs = %GENERIC_READ OR %GENERIC_WRITE
    END IF

    ShareMode = MIN(MAX(ShareMode, 1), 4)    ' Coherce between 1-4
    IF ShareMode = 1 THEN                    ' 1 Deny read/write access.
       ShareIs = 0
    ELSEIF ShareMode = 2 THEN                ' 2 Deny write access.
       ShareIs =  %FILE_SHARE_READ
    ELSEIF ShareMode = 3 THEN                ' 3 Deny read access.
       ShareIs =  %FILE_SHARE_WRITE
    ELSE                                     ' 4 Deny none (full share mode).
       ShareIs =  %FILE_SHARE_READ OR %FILE_SHARE_WRITE
    END IF

    IF hFile = -1 THEN
       FlagAndAttribute = %FILE_ATTRIBUTE_NORMAL OR %FILE_FLAG_WRITE_THROUGH
    ELSE
       FlagAndAttribute = %FILE_ATTRIBUTE_NORMAL
    END IF

    hFile = CreateFileA(zFilName, AccessIs, ShareIs, BYVAL %NULL, %OPEN_ALWAYS, FlagAndAttribute, BYVAL %NULL)

    IF hFile = CLNG(%INVALID_HANDLE_VALUE) THEN    ' -1 Fail to create the file
       FUNCTION = GetLastError()             ' Set the error code
       hFile = 0                             ' Reset handle number
    END IF

END FUNCTION

FUNCTION zsFGetAt (BYVAL hFile AS LONG, BYVAL nPosByte AS LONG, Buf$) AS LONG
    LOCAL nErrCode AS LONG
    nErrCode = zsFSeek(hFile, nPosByte)
    IF nErrCode = 0 THEN nErrCode = zsFGet(hFile, Buf$)
    FUNCTION = nErrCode
END FUNCTION

FUNCTION zsFlof (BYVAL hFile AS LONG) AS LONG
    IF GetFileType(hFile) = %FILE_TYPE_DISK THEN
       LOCAL fSize AS LONG
       fSize = GetFileSize(hFile, BYVAL %NULL)
       IF fSize > -1 THEN FUNCTION = fSize
    END IF
END FUNCTION

FUNCTION zsFSeek (BYVAL hFile AS LONG, BYVAL PosByte AS LONG) AS LONG
    IF SetFilePointer(hFile, PosByte, BYVAL %NULL, %FILE_BEGIN) < 0 THEN
       FUNCTION = GetLastError()
    END IF
END FUNCTION

FUNCTION zsFGet (BYVAL hFile AS LONG, StringBuf AS STRING) AS LONG
    IF hFile THEN
       LOCAL LenBuf, ByttesReaded AS LONG
       LenBuf = LEN(StringBuf)
       IF LenBuf THEN
          IF ReadFile(hFile, BYVAL STRPTR(StringBuf), LenBuf, ByttesReaded, BYVAL %NULL) = 0 THEN
             FUNCTION = GetLastError()
          END IF
       END IF
    END IF
END FUNCTION

FUNCTION zsFPut (BYVAL hFile AS LONG, BYVAL Buf$) AS LONG
    LOCAL LenBuf, ByttesWritten AS LONG
    IF hFile THEN
       LenBuf = LEN(Buf$)
       IF LenBuf THEN
          IF WriteFile(hFile, BYVAL STRPTR(Buf$), LenBuf, ByttesWritten, BYVAL %NULL) = 0 THEN
             FUNCTION = GetLastError()
          END IF
       END IF
    END IF
END FUNCTION

SUB zsFClose ALIAS "zsFClose" (hFile AS LONG)
    IF hFile THEN CALL CloseHandle(hFile)
    hFile = 0
END SUB

'// Kill directly a file without sending it to recycle.bin
FUNCTION zsKillFile (zFullName AS ASCIIZ) EXPORT AS LONG
    LOCAL zTmp AS ASCIIZ * %MAX_PATH, sPathName, sToKill AS STRING
    sPathName = PATHNAME$(PATH, zFullName)
    sToKill = DIR$(zFullName, 39) ' %NORMAL + %READONLY + %HIDDEN + %SYSTEM + %ARCHIVE
    DO WHILE LEN(sToKill)
       zTmp = sPathName + sToKill
       CALL SetFileAttributesA(zTmp, %FILE_ATTRIBUTE_NORMAL)
       IF DeleteFileA(zTmp) = 0 THEN FUNCTION = GetLastError(): EXIT DO
       sToKill = DIR$
    LOOP
END FUNCTION

' Changes the character being used as delimiter to read in a sequential text file.
FUNCTION zsSetBufinChar (BYVAL Char$) STATIC AS STRING
    IF LEN(Char$) THEN UserChar$ = Char$
    IF LEN(UserChar$) THEN
       FUNCTION = UserChar$
    ELSE
       FUNCTION = CHR$(13)
    END IF
END FUNCTION

FUNCTION zsBufin(zFileName AS ASCIIZ, nDone AS LONG) STATIC AS STRING
DIM sCr AS STRING, sBuffer AS STRING
DIM hFile AS LONG, nLocation AS LONG, nBufSize AS LONG, nBufPos AS LONG, nErrCode AS LONG, nRemaining AS LONG
DIM nCr AS LONG, nSlop AS LONG, nReading AS LONG, nLenCr AS LONG, nSizeFile AS LONG, nSaveCr AS LONG
IF LEN(zFileName) THEN

   IF NOT nReading THEN
      sCr = zsSetBufinChar("")          ' added for spec char
      nReading = -1: nDone = 0
      IF ASC(sCr) = 13 THEN             ' added for spec char
         nLenCr = 0: sCr = CHR$(13)
      ELSE                              ' added for spec char
         nLenCr = LEN(sCr)              ' added for spec char
      END IF                            ' added for spec char
      nCr = 0: nLocation = 0
      IF NOT ISFILE(zFileName) THEN
         GOTO BufEnd  ' Nothing to do
      END IF
      nErrCode = zsFOpen(zFileName, 0, 2, hFile)
      IF nErrCode THEN
         nDone = nErrCode: nReading = 0
         EXIT FUNCTION
      END IF
      nRemaining = zsFlof(hFile)                 ' Bytes count to be read
      nSizeFile = nRemaining                     ' Remember this
      IF nRemaining = 0 GOTO BufEnd              ' Nothing to read
      nBufSize = 16384
      sBuffer = SPACE$(nBufSize)
   END IF
   DO WHILE nRemaining                           ' While more in the file
      IF nCr = 0 THEN                            ' If no return was found
         IF nRemaining < nBufSize THEN           ' read only what remains.
            nBufSize = nRemaining                ' Resize the buffer.
            IF nBufSize < 1 THEN EXIT DO         ' Possible only if EOF 26.
            sBuffer = SPACE$(nBufSize)
         END IF
         nErrCode = zsFGetAt(hFile, nLocation, sBuffer) ' Read a bloc.
         nLocation = nLocation + nBufSize        ' Here we are.
         nBufPos = 1                             ' Start at the beginning
      END IF                                     ' of that bloc.
      DO                                         ' Walk through buffer.
         nCr = INSTR(nBufPos, sBuffer, sCr)      ' Look for a Return.
         IF nLenCr = 0 THEN                      ' Do this to read files with
            nLenCr = 1                           ' or without LF after CR.
            IF ASC(sBuffer, nCr + 1) = 10 THEN nLenCr = 2
         END IF
         IF nCr THEN                             ' We found one.
            nSaveCr = nCr                        ' Save where
            FUNCTION = MID$(sBuffer, nBufPos, nCr - nBufPos)
            nBufPos = nCr + nLenCr               ' In case of LF skip it
            EXIT FUNCTION                        ' all done for now.
         ELSE                                    ' Back up in the file.
          ' If we reached the end of file and no nCr
          ' was found, return what remains in the string.
            IF nLocation >= nSizeFile THEN
             ' Assign function and trap ^Z
               FUNCTION = RTRIM$(MID$(sBuffer, nSaveCr + nLenCr), CHR$(26))
               nRemaining = nBufSize
               EXIT DO
            END IF
          ' 05-06-1998 () were missing on each side of (nLenCr - 1)
            nSlop = nBufSize - nSaveCr - (nLenCr - 1) ' Calc buffer excess.
            nRemaining = nRemaining + nSlop           ' Calc file excess.
            nLocation = nLocation - nSlop
         END IF
      LOOP WHILE nCr
      nRemaining = nRemaining - nBufSize
      nSaveCr = 0
   LOOP
END IF

BufEnd:
nReading = 0: nDone = -1: CALL zsFClose(hFile)
END FUNCTION

